// bs225.h - BS225 SUMMA pattern unit
//
// Mar-2004 by Solo, adapted from Serge sources
//

#ifndef _BS225_H
#define _BS225_H

#include "le20c.h"

class BS225
{

 public:
// Constructor and destructor
  BS225 (LE20C* host, int number, int mask = 0xff)
  {
    h = host;
    n = number;
    le = 0;
    //    restart (0xff & mask);
  }

  ~BS225 () {}

// Functions and procedures
  void restart (int newmask = 0x100)
  {
    if (newmask != 0x100) {
      newmask = (0xff & newmask);
      setmask (newmask);
    }
    clear ();
  }

  void clear ()           { h->read (n, 0); h->act (n, 0, 26); }
  int  getmask ()         { return (int)h->read (n, 1); }
  void setmask (int mask) { m=mask; h->write (n, 1, (short)m); }
  int  last_event ()      { return le; }

  int  event ()
  {
    short data = h->read (n, 0);
    le = (((data & 0x80) == 0) ? 0 : (data & 0x7f) + 1);
    return le;
  }

 private:
  LE20C* h;
  int n;
  int m;
  int le;
};

# endif
