// tb207.h - SUMMA test output for chambers 
//
// Nov-2005 by Solo
//

#ifndef _TB207_H
#define _TB207_H

#include "le20c.h"

class TB207
{

 public:
// Constructor and destructor
  TB207 (LE20C* host, int number=20, int pattern=0xffffffff)
  {
    h = host;
    n = number;
    write(pattern);
  }

  ~TB207 () {}

// Functions and procedures
  void write(int pattern) {
    pa=pattern; 
    h->write(n,0,pattern&0xffff); // low order 16 bit
    h->write(n,1,(pattern>>16)&0xffff); // high order 16 bit
  }

 private:
  LE20C* h; // QBUS-SUMMA host
  int n;    // position in crate
  int pa;   // 32pit pattern 
};

# endif
