// le30.cc - test for LE30/LE15 prop chamber electronics
//
//  Nov-2005 by Solo
//

#include <stdio.h>
#include <string.h>
//#include "le20i.h"
#include "le83.h"
#include "le20c.h"
#include "t162.h"
#include "tb207.h"
#include "le35.h"

#define MAXDATA 1024

int main(int argc, char **argv)
{
  char qname[80]="/dev/qbus0";
  int summa_crate=4;
  int miss_crate=6;
  int t162_num=19;
  int tb207_num=20;
  int le35_num=21;
  int events=1;
  int memory=56;
  int n;
  unsigned int pattern=1;
  short data[MAXDATA];

  //  if(argc<5) {
  //    printf("Usage: le30 qbus crate num cmd \n");
  //    printf("       qbus  = 0-1  - qbus number or /dev/xxx \n");
  //    printf("       crate = 0-15 - miss crate number \n");
  //    printf("       num   = 0-31 - miss module number \n");
  //    printf("       cmd   = p    - print contents \n");
  //    printf("               v    - verify contents \n");
  //    return 0;
  //  }

  //  strncpy(qname,argv[1],sizeof(qname));
  //  if(argv[1][0]=='0') strcpy(qname,"/dev/qbus0");
  //  if(argv[1][0]=='1') strcpy(qname,"/dev/qbus1");

  //  sscanf(argv[2],"%d",&crate);
  //  if(crate<0 || crate>15) { 
  //    printf("miss crate %d is out of [0-15] range\n",crate); 
  //    return -1;
  //  }

  //  sscanf(argv[3],"%d",&num);
  //  if(num<0 || num>31) { 
  //    printf("miss module number %d is out of [0-31] range\n",num); 
  //    return -1;
  //  }

  if(argc>1) sscanf(argv[1],"%i",&pattern);
  if(argc>2) sscanf(argv[2],"%d",&events);
  if(argc>3) sscanf(argv[3],"%d",&memory);

  QBUS qb(qname);
  if(qb.node()<0) return -1;

  LE20C su(&qb, summa_crate);
  LE83 mi(&qb, miss_crate);

  su.Z();

  T162 tt(&su, t162_num);
  TB207 tb(&su, tb207_num, pattern);
  LE35 me(&su, le35_num);
  
  tt.pulse(1); // stop LE-16
  //  usleep(100);
  tt.pulse(2); // send clear "OC"
  tt.pulse(2); // repeat for old ctrls
  //  usleep(100);
  if(memory==56) mi.Z(); 

  while(events-->0) {
    tt.pulse(0); // start to LE-16
    usleep(100); // run generator
    tt.pulse(1); // stop to LE-16
    //    usleep(10); // give time to LE30 to run
    memset(data,0,sizeof(data)); 

    if(memory==35) n=me.read(data,MAXDATA);
    else if(memory==56) { n=mi.sdata(MAXDATA,data); mi.Z(); }
    else n=0;

    printf("read %d words\n",n);
    if(n>0) {
      for(int i=0; i<n; i++) {
	printf("data[%d]=0x%04hx ",i,data[i]);
	// first control word
	if(data[i+1]&0x8000) {
	  printf("sect=%d event=%d\n",data[i]>>10,data[i]&0x3ff);
	}
	// second control word
	else if(data[i]&0x8000) {
	  printf("type=%d length=%d\n",(data[i]>>11)&3,data[i]&0x07ff);
	}
	else {
	  printf("chan=%d mod=%d time=%d\n",data[i]&63,(data[i]>>6)&31,data[i]>>11);
	}
      }
      printf("\n");
    }
  }

  return 0;
}
