// le71_qbus3.cc - complex test le71 work with Le20I (using only qbus device functions)
//
//  Mar-2004 by Matveev
                                                           
 
                                                                     
#include <curses.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include "qbus.h"

void set_command_le71(int , int , int );
void set_state_le71(int );
int read_state_le71();
void write_ped(int,int);
void write_in(int,int);
int read_ped(int);
int read_in(int);
short status();
int tr ();
int gt ();
int bus_error ();

int base;
int bchan=1; // defolt adr. adc chanal
int n=2; // defolt number le71 module
int data;
int chan;
int avto =0;
int ped =1;
int rpchi =0;
int incchan = 0;
char qname[180];
QBUS* qb;

int main(int argc, char **argv)
{                                                    
   int crate=1; // number crate ( number le20I)
   int base0 =0xfe00; // base adr qbus for crate 0
   int num [40];
   int adrch [100];
   int datach [100];
   int ending;
   int delta;
   int rdata;
   char contr;
   char cycle;
   int err;
   int i;
   int key=0;
   int count=0;
   
  if(argc<4) {
    printf("Usage: le71_qbus2 dev crate num chan cmd contr cycle   \n");
    printf("       dev = 0,1 or /dev/xxx \n");
    printf("       crate = 0-15  \n");
    printf("       num = 0-30  \n");
    printf("       chan = 0-95  \n");
    printf("       cmd = reset      - reset QBUS branch \n");
    printf("             p        -write-read ped ,no avto+adr in le71  \n");
    printf("             pd       - write-read ped and in data,no avto+adr in le71   \n");
    printf("             d       - write-read in data, no avto+adr in le71   \n");
    printf("             d-p      - write ped and indata -read (indata - ped) in PCHI mode \n");
    printf("             contr = p - contr + print   \n");
    printf("                     v- only contr   \n");
    printf("                     n - without control   \n");
    printf("             cycle = y - yes cycle programm ,out of cycle-kl.[probel] \n");
    printf("                     n - no cycle programm  \n");


    return 0;
   }
    initscr();    // init curses
    SCREEN * myscreen = newterm(NULL,stdout,stdin); // init new screen

    halfdelay(1); // time to wait for key press in 1/10 of seconds
    noecho();     // do not echo pressed key
    nonl();       // do not traslate return to new line and vice versa
    intrflush(stdscr, FALSE); // do not flush on interrupt
    keypad(stdscr, TRUE);  // allow input from keypad
    endwin();







  strncpy(qname,argv[1],strlen(qname));
  if(argv[1][0]=='0') strcpy(qname,"/dev/qbus0");
  if(argv[1][0]=='1') strcpy(qname,"/dev/qbus1");


  qb = new QBUS(qname);

  if(qb->node()<0) return -1;

  // RESET
               if(strcmp(argv[5],"reset")==0) {
    qb->reset();
    return 0;
   }
 sscanf(argv[2],"%d",&crate);
  if(crate<0 || crate>15) {
    printf("crate number %d is out of [0-15] range\n",crate);
    return -1;
   }
 sscanf(argv[3],"%d",&n);
  if(n<0 || n>29) {
    printf("module number %d is out of [0-29] range\n",n);
    return -1;
   }

 base = base0 + crate*0x10;

   // Find module in crate

   qb->write (base, 3); // write RK to kommutator
   qb->write (base+2, 0x40); //  Set PCHN mode
   int cnt = 0;
   int cnt1 =0;
   if (tr ())
    {
       set_command_le71 (0,0,0);         //  Set F(0) function
       do
	 {
	   if (cnt++ >= 29)
	     {
	       printf(" number of modules %d is out of [29] range\n",cnt);
	       return cnt;
	     }
	   ending = !tr ();
	   if ( (qb->read (base +0x04)& 0x0f80) == (n <<7))
	     {
	       printf("  module number %d is fined \n",n);
	       goto M0;
	     }
	 } while (!ending);
    }
   printf("  module number %d is not fined \n",n);
   qb->write (base, 3); // write RK to kommutator
   qb->write (base+2, 0x00); //  Return AP mode
   return cnt;

M0: qb->write (base, 3); // write RK to kommutator
    qb->write (base+2, 0x00); //  Return AP mode

 sscanf(argv[4],"%i",&bchan);
 if(bchan<0 || bchan>95) {
   printf("adc chanal number %d is out of [0/1-95] range\n",chan);
   return -1;
    }
 sscanf(argv[6],"%c",&contr);
 if(contr != 'p' && contr != 'v' && contr != 'n')
    {
   printf("control parametr is not correctr, must be n,v,p \n");
   return -1;
    }
 sscanf(argv[7],"%c",&cycle);
 if(cycle != 'y' && cycle != 'n') {
   printf("cycle  parametr is not correct,must be y,n \n");
   return -1;
    }

  // BEGINE WRITE-READ
   if((strcmp(argv[5],"pd")!=0) && (strcmp(argv[5],"d-p")==0) &&
   (strcmp(argv[5],"p")==0) && (strcmp(argv[5],"d")==0))
    {
   printf("cmd  parametr is not correct , must be p,d,pd,d-p \n");
   return -1;
    }
 // ANALYSE WRITE-READ PED AND INDATA WITH COMPARE on CONSTANT difference
   if ((strcmp(argv[5],"pd")==0) || (strcmp(argv[5],"d-p")==0))
 {
   if (strcmp(argv[5],"pd")==0) {
   printf("write-read ped and indata  with compare constant difference for  %d to 95 channals  \n",bchan);
   avto = 0x00;
   rpchi = 0;
     }
   if (strcmp(argv[5],"d-p")==0) {
   printf("write-read ped and indata and read  in PCHI constant defference (indata-ped) for channal from %d to 96  \n",bchan);
   avto = 0x00;
   rpchi = 1;
     }
  // WRITE-READ PED and INDATA
   err = 0;
   incchan =1;
 do { 
   ped = 1;
   delta = 0;
  M2: qb->write(base+0xa,bchan);// set begine adr.adc chanal
  set_command_le71(n,1,3);
   data = bchan ;
   chan = bchan;
// WRITE
   for ( i = bchan; i <= 95; i++)
   {
   if (ped ==1){
   write_ped(data,avto);
    }
   else {
   write_in (((data <<1)+delta) ,avto);
    }
   data = data + incchan;
   chan = chan + incchan;
   }
   if (contr == 'n'){
   printf (" no control ,end write \n");
   goto M3;
    }
    if (ped == 1){
   printf (" end write_ped  \n");
    }
    else printf (" end write_indata  \n");

  // READ
  qb->write(base+0xa,bchan);// set begine adr.adc chanal
  set_command_le71(n,1,3);
   data = bchan;
   chan = bchan;
   for ( i = bchan; i <= 95; i++)
   {if (ped ==1){
   rdata = read_ped(avto);
    }
   else {
   rdata = (read_in(avto) - delta) >> 1;
    }

   if (rdata != data){
   err++;
   if (contr == 'p'){
   printf ( "write data %d != read data %d in channal=%d \n",data,rdata,chan);
     }
    }
   data = data + incchan;
   chan = chan + incchan;
   }
   if (ped == 1){
   printf ("end read_ped \n");
   }
   else printf ("end read_indata \n");
  if ( delta == 0){
  delta = delta +200;
  incchan = incchan + 0;
  ped = 0;
  goto M2;
   }
 
 M3: key = getch(); endwin();

     //    sleep(1);

 }while ( (cycle == 'y') && (rpchi == 0) && (key != 32));// cycle and no kl." probel"
  if (rpchi == 0){ 
  printf (" end test write-read ped and indata , errors = %d\n",err);
   delscreen(myscreen);
   return 0;
   }
 
 
 
  // READ (INDATA-PED) IN PCHI MODE
 
 do 
 {
 
  qb->read (base+0x0a); // send le20i sinpulse for start imitation  data convert in le71
  sleep(1);
  set_state_le71(0x06);// set test mode in le71
  qb->write (base, 3); // write RK to kommutator
  qb->write (base+2, 0x80); //  Set PCHI mode
  
  cnt = 0;
  cnt1 = 0;
   if (tr ())
     {
 set_command_le71 (0,0,0);         //  Set F(0) function
      do
	 {
	 
	   if (cnt >= 100)
	     {
	       printf(" overflow buffers  data for reading in PCHI mode = 100 \n");
	       goto M4;
	     }
	   ending = !tr ();
	   datach[cnt] = qb->read (base+0x0c) ; // read data
	   adrch[cnt] =  qb->read (base+0x04)  & 0x7F; // Read adr.channal
	   if ((contr != 'n') && ( adrch[cnt] >= bchan )){
	   cnt1++;
	   if ((adrch[cnt]+200) != datach[cnt] ) {
	   err++;
	   if (contr == 'p') {
	   printf ("Error PCHI read  channal adr= %d ,read data = %d ,must data = %d (write P=A,D=2A+200)\n",adrch[cnt],datach[cnt],(adrch[cnt]+200)); 
	      } 
	     }
	    }  
	   cnt ++;
	 } while (!ending);
     }
   else {
     printf(" no data  for reading in PCHI mode \n");
    // qb->write (base, 3); // write RU to kommutator
    // qb->write (base+2, 0x00); //  Return AP mode
     // qb->write (base, 0); // write RK to kommutator
    // return -1;
        }
  key = getch(); endwin();

     //    sleep(1);
       qb->write (base, 3); // write RU to kommutator
       qb->write (base+2, 0x00); //  Return AP mode
       qb->write (base, 0); // write RK to kommutator
       printf ("end cycle, all data = %d, compare data = %d, errors= %d \n",cnt,cnt1,err);
  }while ((cycle == 'y') && (key != 32));// cycle and no kl." probel"

M4:     delscreen(myscreen);
     if (contr == 'n'){
     printf ("end  test witout control\n");
     }
     printf (" end pchi read test, all errors = %d \n",err);
     qb->write (base, 3); // write RU to kommutator
     qb->write (base+2, 0x00); //  Return AP mode
     qb->write (base, 0); // write RK to kommutator
     set_state_le71(0x00);// set work mode in le71
    return 0;

 }
  // WRITE-READ WITHOUT AVTO-INCREMENT CHANNAL
 if ((strcmp(argv[5],"p")==0) || (strcmp(argv[5],"d")==0))
 {
  if (strcmp(argv[5],"p")==0) {
   printf("write-read ped  \n");
   avto = 0x00;
   ped = 1;
   }
   if (strcmp(argv[5],"d")==0) {
   printf("write-read indata \n");
   avto = 0x00;
   ped = 0;
   }
   
   printf("write-read from channal = %d to channal= 95 \n",bchan);
   incchan=1;
   
  err = 0;
  do
  {
   delta = 0;
  M5: qb->write(base+0xa,bchan);// set begine adr.adc chanal
  set_command_le71(n,1,3);
   data = bchan + delta;
   chan = bchan;
// WRITE
   for ( i = bchan; i <= 95; i++)
   {
   if (ped ==1){
   write_ped(data,avto);
    }
   else {
   write_in (data,avto);
    }
   data = data + incchan;
   chan = chan + incchan;
   }
   if (contr == 'n'){
   printf (" no control ,end write \n");
    set_state_le71(0x00);// set work mode in le71
   return 0;
    }
   printf (" end write  \n");

  // READ
  qb->write(base+0xa,bchan);// set begine adr.adc chanal
  set_command_le71(n,1,3);
   data = bchan + delta;
   chan = bchan;
   for ( i = bchan; i <= 95; i++)
   {if (ped ==1){
   rdata = read_ped(avto);
    }
   else {
   rdata = read_in(avto);
    }

   if (rdata != data){
   err++;
   if (contr == 'p'){
   printf ( "write data %d != read data %d in channal=%d \n",data,rdata,chan);
     }
    }
   data = data + incchan;
   chan = chan + incchan;
   }
   printf ("end read \n");
  if ( delta == 0){
  delta = delta +64;
  goto M5;
   }

    //  printf("count is %d\n",++count); endwin();

        key = getch(); endwin();

      //  printf(" key is %3d\n",key); endwin();

    //    sleep(1);

  }while ((cycle == 'y') && (key != 32));// cycle and no kl." probel"

printf (" end test, errors = %d \n", err);
delscreen(myscreen);
 set_state_le71(0x00);// set work mode in le71
return 0;
 }
}


 void set_command_le71(int n,int a,int f)
  {
  int command;
  command = ((f & 7) << 12) + ((n & 0x1f) << 7) + (a & 0x7f);
  qb->write(base, 0); // write RK to kommutator
  qb->write(base+2, command);
  }

  void set_state_le71(int state)
  {
    qb->write(base+0xa, state);
    set_command_le71(n,0,3 );
  }
  int read_state_le71()
  {
  set_command_le71(n,0,0);
  return qb->read(base+0xC);
  }
  void write_ped(int data, int avto)
  {
  set_state_le71(0x02+avto);
  if (avto == 0) {
  qb->write(base+0xa,chan);// write adr.adc chanal
  set_command_le71(n,1,3);
  }
  qb->write(base+0xa,data);// write ped to chanal
  set_command_le71(n,3,3);
  }
  void write_in(int data, int avto)
  {
  set_state_le71(0x02+avto);
  if (avto == 0) {
  qb->write(base+0xa,chan);// write adr.adc chanal
  set_command_le71(n,1,3);
  }
  qb->write(base+0xa,data);// write indata to chanal
  set_command_le71(n,2,3);
  }
  int read_ped(int avto)
  {
  set_state_le71(0x02+avto);
  if (avto == 0){
  qb->write(base+0xa,chan);// write adr.adc chanal
  set_command_le71(n,1,3);
  }
  set_command_le71(n,3,0);
  return qb->read(base+0xc);// read ped from chanal
  }
  int read_in(int avto)
  {
  set_state_le71(0x02+avto);
  if (avto == 0){
  qb->write(base+0xa,chan);// write adr.adc chanal
  set_command_le71(n,1,3);
  }
  set_command_le71(n,2,0);
  return qb->read(base+0xc);// read indata from chanal
  }
  short status()
  { qb->write(base, 1); return qb->read(base+0x02); } // Get status
    int tr ()
  {  return ((status () & 0x10) > 0);  }
  int gt ()
  {  return ((status () & 0x20) > 0);  }
  int bus_error ()
  {  return ((status () & 0x80) > 0);  }

