#include <QHBoxLayout>
#include "le90m_parameter.h"

LE90Mparameter::LE90Mparameter(const QString &text, const QString &suffix, bool enabled, QWidget *parent) : QWidget(parent)
{ 
  label = new QLabel(text);
  spinbox = new QDoubleSpinBox();
  spinbox->setRange(0.0,9.9);
  spinbox->setSingleStep(0.1);
  spinbox->setDecimals(1);
  spinbox->setSuffix(suffix);
  spinbox->setEnabled(enabled);

  QHBoxLayout *layout = new QHBoxLayout;
  layout->setContentsMargins(0,0,0,0);    // set minimum margins
  layout->addWidget(label);
  layout->addWidget(spinbox);
  setLayout(layout);
}

void LE90Mparameter::displayParameter(double val)
{
  spinbox->setValue(val);
}
