// le90m.C - GUI for LE90M control
//
// Nov-2007 by Solo

// main window constructor
void le90m_main_window()
{
  // first create main frame window
  TGMainFrame *fMain = new TGMainFrame(0,200,400,kMainFrame|kVerticalFrame); 

  // Create setup frame
  TGGroupFrame *fSetup = new TGGroupFrame(fMain,"Setup",kHorizontalFrame);
  fMain->AddFrame(fSetup, new TGLayoutHints(kLHintsExpandX,10,10,10,10));

  TGLabel *lQbus = new TGLabel(fMain,"QBUS device");
  fSetup->AddFrame(lQbus, new TGLayoutHints(kLHintsNormal,5,5,13,0));

  TGTextEntry *tQbus = new TGTextEntry(fMain,"/dev/iq0");
  fSetup->AddFrame(tQbus, new TGLayoutHints(kLHintsNormal,5,5,10,0));

  TGLabel *lCrate = new TGLabel(fMain,"Crate");
  fSetup->AddFrame(lCrate, new TGLayoutHints(kLHintsNormal,20,5,13,0));  

  TGNumberEntry *nCrate = new TGNumberEntry(fSetup,4,2);
  nCrate->SetLimits(TGNumberFormat::kNELLimitMinMax,0,15);
  fSetup->AddFrame(nCrate, new TGLayoutHints(kLHintsNormal,0,5,0,0));

  TGLabel *lModule = new TGLabel(fMain,"Module");
  fSetup->AddFrame(lModule, new TGLayoutHints(kLHintsNormal,20,5,13,0));  

  TGNumberEntry *nModule = new TGNumberEntry(fSetup,4,2);
  nCrate->SetLimits(TGNumberFormat::kNELLimitMinMax,1,21);
  fSetup->AddFrame(nModule, new TGLayoutHints(kLHintsNormal,0,5,0,0));

  // Create command frame
  
  TGHorizontalFrame *fCommand = new TGHorizontalFrame(fMain,200,50);
  fMain->AddFrame(fCommand, new TGLayoutHints(kLHintsExpandX,10,10,10,10));

  TGLayoutHints *cHints = new TGLayoutHints(kLHintsRight,5,5,3,4);
  
  // Create buttons
  TGTextButton *bUpdate = new TGTextButton(fCommand,"&Update");
  fCommand->AddFrame(bUpdate, cHints);;

  TGTextButton *bExit = new TGTextButton(fCommand,"&Exit","gApplication->Terminate(0)");
  fCommand->AddFrame(bExit, cHints);


  //  TGButtonGroup *bTrig = new TGButtonGroup(cFrame,"Trigger type",kHorizontalFrame);
  //TGRadioButton *bPed = new TGRadioButton(bTrig, new TGHotString("&Ped"));
  //TGRadioButton *bLed = new TGRadioButton(bTrig, new TGHotString("&LED"));
  //bPed->SetState(kButtonDown);
  //cFrame->AddFrame(bTrig, cHints);

  // status bar
  Int_t parts[] = {80, 20};
  TGStatusBar *fSbar = new TGStatusBar(fMain,50,10,kHorizontalFrame);
  fSbar->SetParts(parts,2);
  fMain->AddFrame(fSbar, new TGLayoutHints(kLHintsBottom|kLHintsLeft|kLHintsExpandX,0,0,2,0));
  //  fSbar->SetText("Trigger=Ped, Cycles=100, Crate=0, Module=1",0);

  // set name, map children, resize and map itself
  fMain->SetWindowName("LE90M Control");
  fMain->MapSubwindows();
  fMain->Resize(fMain->GetDefaultSize());
  fMain->MapWindow();
}

void le90m() {
  le90m_main_window();
}
