// main window constructor
void main_window()
{
  // first create main frame window
  TGMainFrame *fMain = new TGMainFrame(gClient->GetRoot(),800,600);

  // then create and place canvas
  TRootEmbeddedCanvas *fEcanvas = new TRootEmbeddedCanvas("Ecanvas",fMain,800,600);
  fMain->AddFrame(fEcanvas, new TGLayoutHints(kLHintsExpandX|kLHintsExpandY,10,10,10,1));

  // Create command frame with buttons
  TGHorizontalFrame *cFrame = new TGHorizontalFrame(fMain,600,50);
  fMain->AddFrame(cFrame, new TGLayoutHints(kLHintsExpandX,10,10,10,1));

  // Create buttons
  TGLayoutHints *cHints = new TGLayoutHints(kLHintsRight,5,5,3,4);
  TGTextButton *bExit = new TGTextButton(cFrame,"&Exit","gApplication->Terminate(0)");
  cFrame->AddFrame(bExit, cHints);

  TGTextButton *bNext = new TGTextButton(cFrame,"&Next");
  cFrame->AddFrame(bNext, cHints);

  TGTextButton *bUpdate = new TGTextButton(cFrame,"&Update");
  cFrame->AddFrame(bUpdate, cHints);

  TGHSlider *sModule = new TGHSlider(cFrame,100,kSlider1|kScaleDownRight,3);
  sModule->SetRange(1,18);
  sModule->SetPosition(1);
  cFrame->AddFrame(sModule, cHints);

  //  TGHSlider *sCrate = new TGHSlider(cFrame,100,kSlider2|kScaleDownRight,2);
  //  sCrate->SetRange(0,5);
  //  sCrate->SetPosition(0);
  //  cFrame->AddFrame(sCrate, cHints);

  TGNumberEntry *nCrate = new TGNumberEntry(cFrame,0,1);
  nCrate->SetLimits(TGNumberFormat::kNELLimitMinMax,0,6);
  cFrame->AddFrame(nCrate, cHints);

  TGHSlider *sCycles = new TGHSlider(cFrame,100,kSlider1|kScaleDownRight,1);
  sCycles->SetRange(1,1000);
  sCycles->SetPosition(100);
  cFrame->AddFrame(sCycles, cHints);

  TGButtonGroup *bTrig = new TGButtonGroup(cFrame,"Trigger type",kHorizontalFrame);
  TGRadioButton *bPed = new TGRadioButton(bTrig, new TGHotString("&Ped"));
  TGRadioButton *bLed = new TGRadioButton(bTrig, new TGHotString("&LED"));
  bPed->SetState(kButtonDown);
  cFrame->AddFrame(bTrig, cHints);

  // status bar
  Int_t parts[] = {80, 20};
  TGStatusBar *fSbar = new TGStatusBar(fMain,50,10,kHorizontalFrame);
  fSbar->SetParts(parts,2);
  fMain->AddFrame(fSbar, new TGLayoutHints(kLHintsBottom|kLHintsLeft|kLHintsExpandX,0,0,2,0));
  fSbar->SetText("Trigger=Ped, Cycles=100, Crate=0, Module=1",0);

  // set name, map children, resize and map itself
  fMain->SetWindowName("ADC Pedestals Framework");
  fMain->MapSubwindows();
  fMain->Resize(fMain->GetDefaultSize());
  fMain->MapWindow();
}
