// bs225.cc - test for SUMMA pattern unit
//
//  Mar-2004 by Solo
//

#include <stdio.h>
#include <string.h>
#include "le20c.h"
#include "bs225.h"

int main(int argc, char **argv)
{
  char qname[80];
  int crate=4;
  int n=18;
  short d, mask;

  if(argc<5) {
    printf("Usage: bs225 qbus crate N cmd \n");
    printf("       qbus  = 0-2  - qbus number or /dev/xxx \n");
    printf("       crate = 0-15 - summa crate number \n");
    printf("       N     = module number in crate \n");
    printf("       cmd   = clear    - clear module \n");
    printf("               set mask - set mask \n");
    printf("               get      - get mask \n");
    printf("               event    - get event \n");
    return 0;
  }

  strncpy(qname,argv[1],sizeof(qname));
  if(argv[1][0]=='0') strcpy(qname,"/dev/qbus0");
  if(argv[1][0]=='1') strcpy(qname,"/dev/qbus1");
  if(argv[1][0]=='2') strcpy(qname,"/dev/qbus2");

  sscanf(argv[2],"%d",&crate);
  if(crate<0 || crate>15) { 
    printf("SUMMA crate %d is out of [0-15] range\n",crate); 
    return -1;
  }

  sscanf(argv[3],"%d",&n);
  if(n<0 || n>24) { 
    printf("SUMMA module number %d is out of [0-24] range\n",n); 
    return -1;
  }

  QBUS qb(qname);
  if(qb.node()<0) return -1;

  LE20C su(&qb, crate);

  BS225 bs(&su, n);

  // CLEAR
  if(strcmp(argv[4],"clear")==0) {
    bs.clear();
  }
  // GET MASK
  else if(strcmp(argv[4],"get")==0) {
    printf("bs225 module %d mask=0x%x\n",n,bs.getmask());
  }
  // SET MASK
  else if(strcmp(argv[4],"set")==0) {
    if(argc<6) {
      printf("Usage: bs225 qbus crate N set mask \n");
      return -1;
    }
    sscanf(argv[5],"%i",&mask);
    bs.setmask(mask);
  }
  // EVENT
  else if(strcmp(argv[4],"event")==0) {
    printf("bs225 module %d event=0x%x\n",n,bs.event());
  }
  // UNKNOWN
  else {
    printf("unknown command: %s\n",argv[4]);
    return -1;
  }

  return 0;
}
