// le35.cc - test for SUMMA register of MISS cable segment
//
//  Nov-2005 by Solo
//

#include <stdio.h>
#include <string.h>
#include "le35.h"

#define MAXDATA 1024
int main(int argc, char **argv)
{
  char qname[80]="/dev/qbus0";
  int crate=4;
  int n=21;
  int s;
  short data[MAXDATA];

  if(argc<2) {
    printf("Usage: le35 cmd [N] [crate] [qbus]\n");
    printf("       cmd   = clear, read \n");
    printf("       N     = module number in crate (default 14)\n");
    printf("       crate = 0-15 - summa crate number (default 4)\n");
    printf("       qbus  = 0-1  - qbus number or /dev/xxx (default 0)\n");
    return 0;
  }

  if (argc>4) {
    strncpy(qname,argv[4],strlen(qname));
    if(argv[1][0]=='0') strcpy(qname,"/dev/qbus0");
    if(argv[1][0]=='1') strcpy(qname,"/dev/qbus1");
  }

  if (argc>3) {
    sscanf(argv[3],"%d",&crate);
    if(crate<0 || crate>15) { 
      printf("SUMMA crate %d is out of [0-15] range\n",crate); 
      return -1;
    }
  }

  if (argc>2) {
    sscanf(argv[2],"%d",&n);
    if(n<0 || n>24) { 
      printf("SUMMA module number %d is out of [0-24] range\n",n); 
      return -1;
    }
  }

  QBUS qb(qname);
  if(qb.node()<0) return -1;

  LE20C su(&qb, crate);

  LE35 mem(&su, n);

  if (strcmp(argv[1],"c")==0) mem.clear();
  else {
    s=mem.read(data,MAXDATA);
    printf("read %d words\n",s);
    for(int i=0; i<s; i++) printf("data[%d]=0x%04hx = %d\n",i,data[i],data[i]);
  }

  return 0;
}
