// tb207.cc - test for SUMMA output pattern unit
//
//  Nov-2005 by Solo
//

#include <stdio.h>
#include <string.h>
#include "tb207.h"

int main(int argc, char **argv)
{
  char qname[80]="/dev/qbus0";
  int crate=4;
  int n=20;
  int pattern=0;

  if(argc<2) {
    printf("Usage: tb207 pattern [N] [crate] [qbus]\n");
    printf("       pattern = 32bit pattern \n");
    printf("       N       = module number in crate (default 20)\n");
    printf("       crate = 0-15 - summa crate number (default 4)\n");
    printf("       qbus  = 0-1  - qbus number or /dev/xxx (default 0)\n");
    return 0;
  }

  if (argc>4) {
    strncpy(qname,argv[4],strlen(qname));
    if(argv[1][0]=='0') strcpy(qname,"/dev/qbus0");
    if(argv[1][0]=='1') strcpy(qname,"/dev/qbus1");
  }

  if (argc>3) {
    sscanf(argv[3],"%d",&crate);
    if(crate<0 || crate>15) { 
      printf("SUMMA crate %d is out of [0-15] range\n",crate); 
      return -1;
    }
  }

  if (argc>2) {
    sscanf(argv[2],"%d",&n);
    if(n<0 || n>24) { 
      printf("SUMMA module number %d is out of [0-24] range\n",n); 
      return -1;
    }
  }

  sscanf(argv[1],"%i",&pattern);

  QBUS qb(qname);
  if(qb.node()<0) return -1;
  LE20C su(&qb, crate);
  TB207 tu(&su, n, pattern);

  return 0;
}
