// le35.h - SUMMA input register for MISS cable segment 
//
// Nov-2005 by Solo
//

#ifndef _LE35_H
#define _LE35_H

#include "le20c.h"

class LE35
{

 public:
// Constructor and destructor
  LE35 (LE20C* host, int number=21)
  {
    h = host;
    n = number;
  }

  ~LE35 () {}

// Functions and procedures
  int read(short *data, int len) { 
    int l=0;
    short d;

    d=h->read(n,0);
    while(h->Q() && n<len) {
      data[l++]=d;
      d=h->read(n,0);
    }
    return l;
  }

  void clear() { h->act(n,0,8); }

 private:
  LE20C* h; // QBUS-SUMMA host
  int n;    // position in crate
};

# endif
