// le71_qbus.cc - simple test le71 work with Le20I (using only qbus device functions)
//
//  Mar-2004 by Matveev
//

#include <stdio.h>
#include <string.h>
#include "qbus.h"

void set_command_le71(int , int , int );
void set_state_le71(short );
int read_state_le71();
void write_ped(int);
void write_in(int);
int read_ped();
int read_in();
short status();
int tr ();
int gt ();
int bus_error ();

int base;
int chan=1; // defolt adr. adc chanal
int n=2; // defolt number le71 module
int data;
char qname[180];
QBUS* qb;

int main(int argc, char **argv)
{


   int crate=1; // number crate ( number le20I)
   int base0 =0xfe00; // base adr qbus for crate 0

   int num [40];
   int ending;

  if(argc<4) {
    printf("Usage: le71_qbus dev crate cmd nm chan   \n");
    printf("       dev = 0,1 or /dev/xxx \n");
    printf("       crate = 0-15  \n");
    printf("       cmd = reset      - reset QBUS branch \n");
    printf("             read_n        - read n module le71 yes,no   \n");
    printf("             read_alln       - read all numbers of modules in crate   \n");
    printf("             read_ped       - read ped from le71   \n");
    printf("             write_ped data - write ped to le71 \n");
    printf("             read_in       - read indata from le71   \n");
    printf("             write_in data - write indata to le71 \n");
    printf("       nm                  =  0-29 number of module  \n");
    printf("       chan                = 0-95 adc chanal \n");
    return 0;
  }

  strncpy(qname,argv[1],strlen(qname));
  if(argv[1][0]=='0') strcpy(qname,"/dev/qbus0");
  if(argv[1][0]=='1') strcpy(qname,"/dev/qbus1");


  qb = new QBUS(qname);

  if(qb->node()<0) return -1;

  // RESET
  if(strcmp(argv[3],"reset")==0) {
    qb->reset();
    return 0;
  }
 sscanf(argv[2],"%d",&crate);
  if(crate<0 || crate>15) {
    printf("crate number %d is out of [0-15] range\n",crate);
    return -1;
  }
 sscanf(argv[4],"%d",&n);
  if(n<0 || n>29) {
    printf("module number %d is out of [0-29] range\n",n);
    return -1;
  }

 base = base0 + crate*0x10;

   // READ_N

 if(strcmp(argv[3],"read_n")==0) {

   qb->write (base, 3); // write RK to kommutator
   qb->write (base+2, 0x40); //  Set PCHN mode
   int cnt = 0;
   
   if (tr ())
     {
       set_command_le71 (0,0,0);         //  Set F(0) function
       do
	 {
	   if (cnt++ >= 29)
	     {
	       printf(" number of modules %d is out of [30] range\n",cnt);
	       return cnt;
	     }
	   ending = !tr ();
	   if ( (qb->read (base +0x04)& 0x0f80) == (n <<7))
	     {
	       printf("  module number %d is fined \n",n);
	       goto M0;
	     }
	 } while (!ending);
     }
   printf("  module number %d is not fined \n",n);
 M0: qb->write (base, 3); // write RK to kommutator
   qb->write (base+2, 0x00); //  Return AP mode
   
   return cnt;
 }

 // READ_ALLN
 
 if(strcmp(argv[3],"read_alln")==0) {

   qb->write (base, 3); // write RU to kommutator
   qb->write (base+2, 0x40); //  Set PCHN mode
   int cnt = 0;
   if (tr ())
     {
 set_command_le71 (0,0,0);         //  Set F(0) function
      do
	 {
	 
	   if (cnt >= 29)
	     {
	       printf(" number of modules %d is out of [30] range\n",cnt);
	       return cnt;
	     }
	   ending = !tr ();
	   num[cnt] = ( qb->read (base+0x04) >> 7) & 0x1F; // Read n module
	 
	   cnt ++;
	 } while (!ending);
     }
   else {
     printf(" all number of modules in crate = %d No MODULES \n",cnt);
     qb->write (base, 3); // write RK to kommutator
     qb->write (base+2, 0x00); //  Return AP mode
     return -1;
   }
  
   printf(" all number of modules in crate = %d  \n",cnt);
   for (int cnt1=0; cnt1<cnt; cnt1++) 
   {
             printf(" number = %d \n",num[cnt1]);
	}
  
   
    qb->write (base, 3); // write RK to kommutator
   qb->write (base+2, 0x00); //  Return AP mode
   
      
   
   return cnt;
 }

 sscanf(argv[5],"%i",&chan);
 if(chan<0 || chan>95) {
   printf("adc chanal number %d is out of [0-95] range\n",chan);
   return -1;
 }

  // READ_PED

   if(strcmp(argv[3],"read_ped")==0) {
    printf("read_ped %d module %d channal = %d \n",n,chan,read_ped());
    return 0;
   }

  // WRITE_PED

  if(strcmp(argv[3],"write_ped")==0) {
  if(argc<7) {
      printf("Usage: le71_qbus dev crate write_ped nm chan data\n");
      return 0;
    }
    sscanf(argv[6],"%i",&data);
    write_ped(data);
    printf("write_ped %d module %d channal = %d \n",n,chan,data);
    return 0;
   }
   // READ_IN

  if(strcmp(argv[3],"read_in")==0) {
    printf("read_in %d module %d channal = %d \n",n,chan,read_in());
    return 0;
   }

  // WRITE_IN

  if(strcmp(argv[3],"write_in")==0) {
  if(argc<7) {
      printf("Usage: le71_qbus dev crate write_in nm chan data\n");
      return 0;
    }
    sscanf(argv[6],"%i",&data);
    write_in(data);
    printf("write_in %d module %d channal= %d \n",n,chan,data);
    return 0;
   }

  // UNKNOWN
  else {
    printf("unknown command: %s\n",argv[3]);
    return -1;
  }
}


 void set_command_le71(int n,int a,int f)
  {
  int command;
  command = ((f & 7) << 12) + ((n & 0x1f) << 7) + (a & 0x7f);
  qb->write(base, 0); // write RK to kommutator
  qb->write(base+2, command);
  }

  void set_state_le71(int state)
  {
    qb->write(base+0xa, state);
    set_command_le71(n,0,3 );
  }
  int read_state_le71()
  {
  set_command_le71(n,0,0);
  return qb->read(base+0xC);
  }
  void write_ped(int data)
  {
  set_state_le71(0x02);
  qb->write(base+0xa,chan);// write adr.adc chanal
  set_command_le71(n,1,3);
  qb->write(base+0xa,data);// write ped to chanal
  set_command_le71(n,3,3);
  }
  void write_in(int data)
  {
  set_state_le71(0x02);
  qb->write(base+0xa,chan);// write adr.adc chanal
  set_command_le71(n,1,3);
  qb->write(base+0xa,data);// write indata to chanal
  set_command_le71(n,2,3);
  }
  int read_ped()
  {
  set_state_le71(0x02);
  qb->write(base+0xa,chan);// write adr.adc chanal
  set_command_le71(n,1,3);
  set_command_le71(n,3,0);
  return qb->read(base+0xc);// read ped from chanal
  }
  int read_in()
  {
  set_state_le71(0x02);
  qb->write(base+0xa,chan);// write adr.adc chanal
  set_command_le71(n,1,3);
  set_command_le71(n,2,0);
  return qb->read(base+0xc);// read indata from chanal
  }
  short status()
  { qb->write(base, 1); return qb->read(base+0x02); } // Get status
    int tr ()
  {  return ((status () & 0x10) > 0);  }
  int gt ()
  {  return ((status () & 0x20) > 0);  }
  int bus_error ()
  {  return ((status () & 0x80) > 0);  }

