// le90m_widget.h - Qt GUI interface for le90m module
//
// Nov-2007 by Solo

#ifndef LE90M_WIDGET_H
#define LE90M_WIDGET_H

#include <QWidget>
#include <QLabel>
#include <QPushButton>
#include <QDoubleSpinBox>
#include <QRadioButton>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QGroupBox>

#include "le90m_setup.h"
#include "le90m_parameter.h"

#include "le90m.h"

class LE90Mwidget : public QWidget
{
  Q_OBJECT

 public:
  LE90Mwidget(LE90M *le, QWidget *parent=0);

 public slots:
   void readLE90M(void);
   void changeM(int);
   void changeP(int);
   void loadFile(void);
   void saveFile(void);

 signals:


 private:  
  LE90MDATA data;
  LE90M *module;
  LE90Msetup *setup_parameter[3];
  LE90Mparameter *manual_parameter[2];
  LE90Mparameter *programmable_parameter[8];

  QRadioButton *fbenabled;
  QRadioButton *fbdisabled;
};
#endif
