// tl2_widget.h - Qt GUI interface for TL2-50 module
//
// Nov-2008 by Solo

#ifndef TL2_WIDGET_H
#define TL2_WIDGET_H

#include <QWidget>
#include <QLabel>
#include <QPushButton>
#include <QDoubleSpinBox>
#include <QRadioButton>
#include <QCheckBox>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QGridLayout>
#include <QGroupBox>
#include <QComboBox>

#include <qwt_plot.h>
#include <qwt_plot_curve.h>
#include <qwt_plot_magnifier.h>
#include <qwt_plot_zoomer.h>

#include "tl2_setup.h"
#include "tl2_mask.h"

#include "tl2.h"

class TL2widget : public QWidget
{
  Q_OBJECT

 public:
  TL2widget(TL2 *tl, QWidget *parent=0);

 public slots:
  void reset(void);
  void changePrescaler(int i);
  void changeTrigger(int i);
  void changeMask(int i);
  void changeBusy(void);
  void loadFile(void);
  void saveFile(void);
  void readTL2(void);

 signals:


 private:
  TL2         *module;
  TL2setup    *setup_parameter[3];
  TL2mask     *input_mask[4][16];
  QCheckBox   *trigger[4];
  QLabel      *row_header[6];
  QLabel      *col_header[18];
  QLineEdit   *inputs[16];
  QLineEdit   *counts[16];
  QLineEdit   *triggers[5];
  QLineEdit   *busy[5];
  QLabel      *psc_label[4];
  QSpinBox    *psc[4];
  QCheckBox   *benabled;
  QCheckBox   *bstatus;

  QwtPlot     *intensityPlot;
  QwtPlotCurve *intensityCurve;
  QwtPlotZoomer *intensityZoomer;
  QwtPlotMagnifier *intensityMagnifier;

  int         cntSpill;
  bool        isSpill;
  double      intx[2048];
  double      inty[2048];
};

#endif
