// go.cc - test for GAMS movement
//
//  Nov-2004 by Solo
//

int GO_X0 = 0;
int GO_Y0 = 0;

#include <stdio.h>
#include <string.h>
#include "go.h"
#include "sys/time.h"  // gettimeofday()



int  get_sk() {
        struct timeval tv;
        struct timezone tz;
        gettimeofday( &tv,&tz );
        return tv.tv_sec ;
}


int main(int argc, char **argv)
{
  char qname[80];
  int crate=4;
  int nx=6;
  int ny=5;
FILE *file;
// FILE *file2;
  CRQ dest_crq;
  XY  dest_xy;

XY dest1_xy;
XY dest2_xy;
XY xy;
XY dest_now;
XY length_path;
XY length_back;
int number;
struct tm mytime;
time_t ltime;

///  read configuration.

FILE *config_file;
 char s[133];
char name[80]="";
  char rest[80]="";
  int value=0;
  int index=0;
config_file = fopen("gams.cfg","r");
if (config_file==NULL) {
 printf("Cannot open file gams.cfg for reading configuration\n");
return -1;
}

while(fgets(s,sizeof(s),config_file)!=NULL) {
    // skip comments
    if(strlen(s)<2 || s[0]=='#' || s[0]==' ' || s[0]=='!' || s[0]=='/') continue;

name[0]=0; rest[0]=0; value=0;
 sscanf(s,"%s %d %s",name,&value,rest);
// if(Debug>0) printf("%s %d %s\n",name,value,rest);
if (strcmp(name,"go_x0")==0) GO_X0 = value;
if (strcmp(name,"go_y0")==0) GO_Y0 = value;
//printf("\nGO_X0 = %d \n GO_Y0 = %d \n",GO_X0,GO_Y0);
}




  if(argc<6) {
    printf("Usage: go qbus crate Nx Ny cmd \n");
    printf("       qbus  = 0-1  - qbus number or /dev/xxx \n");
    printf("       crate = 0-15 - summa crate number \n");
    printf("       Nx,Ny = module numbers in crate \n");
    printf("       cmd   = print - current position \n");
    printf("             = move c r q - move to column/row/quarter \n");
    printf("             = go x y     - go to x y coordinates \n");
    printf("             = stop       - stop the movement \n"); 
  }

  strncpy(qname,argv[1],sizeof(qname));
  if(argv[1][0]=='0') strcpy(qname,"/dev/qbus0");
  if(argv[1][0]=='1') strcpy(qname,"/dev/qbus1");

  sscanf(argv[2],"%d",&crate);
  if(crate<0 || crate>15) { 
    printf("SUMMA crate %d is out of [0-15] range\n",crate); 
    return -1;
  }

  sscanf(argv[3],"%d",&nx);
  if(nx<0 || nx>24) { 
    printf("SUMMA module number %d is out of [0-24] range\n",nx); 
    return -1;
  }

  sscanf(argv[4],"%d",&ny);
  if(ny<0 || ny>24) { 
    printf("SUMMA module number %d is out of [0-24] range\n",ny); 
  }

  QBUS qb(qname);
  if(qb.node()<0) return -1;

 LE20C su(&qb, crate);

char adres1[128];
sprintf(adres1,"log.txt");
file=fopen(adres1,"a");


 //file=stdout;

 GO gad(&su, nx, ny,file); //,file2);

  // PRINT
  if(strcmp(argv[5],"print")==0) {
    gad.print();
  }
  // MOVE
  else if(strcmp(argv[5],"move")==0) {
    if(argc<9) {
      printf("Usage: go qbus crate Nx Ny m column row quarter \n");
      return -1;
    }
    sscanf(argv[6],"%d",&dest_crq.column);
    sscanf(argv[7],"%d",&dest_crq.row);
    sscanf(argv[8],"%d",&dest_crq.quarter);
    gad.move(&dest_crq);
  }

  // GO
 else if(strcmp(argv[5],"go")==0) 
{
   if(argc<8){
     printf("Usage: go qbus crate Nx Ny go x y \n");
     return -1;
    }
    sscanf(argv[6],"%d",&dest_xy.X);
    sscanf(argv[7],"%d",&dest_xy.Y);
    gad.move(&dest_xy);
}



  else if(strcmp(argv[5],"stop")==0) {
    printf("Stopping...\n");
    gad.stop();
  }
 // UNKNOWN
  else {
    printf("unknown command: %s\n",argv[5]);
    return -1;
  }

  return 0;
}
