// le90M.cc - test module sihroniz. for BEC with SUMMA interface
//
// Mar-2007 by Matveev
// Nov-2007 by Solo

#include <stdio.h>
#include <string.h>
#include "le90m.h"

int main(int argc, char **argv)
{
  char qname[80];
  int crate=4;
  int module=20;
  int a,p;

  if(argc<5) {
    printf("Usage: le90m qbus crate module cmd \n");
    printf("       qbus   = 0-2  - qbus number or /dev/xxx \n");
    printf("       crate  = 0-15 - summa crate number \n");
    printf("       module = 1-21 - summa module number \n");
    printf("       cmd    = print     - print formatted contents of LE90M module \n");
    printf("              = tbs [n]   - read/write tbs \n");
    printf("              = tgate [n] - read/write tgate \n");
    printf("              = disable   - disable manual programming \n");
    printf("              = enable    - enable manual programming \n");
    printf("              = read a    - read programmable parameter a \n");
    printf("              = write a p - write programmable parameter a with value p\n");  
    printf("              = save file - save configuration to file\n");
    printf("              = load file - load configuration from file\n");
    return 0;
  }

  strncpy(qname,argv[1],sizeof(qname));
  if(argv[1][0]=='0') strcpy(qname,"/dev/qbus0");
  if(argv[1][0]=='1') strcpy(qname,"/dev/qbus1");
  if(argv[1][0]=='2') strcpy(qname,"/dev/qbus2");

  sscanf(argv[2],"%d",&crate);
  if(crate<0 || crate>15) { 
    printf("SUMMA crate %d is out of [0-15] range\n",crate); 
    return -1;
  }

  sscanf(argv[3],"%d",&module);
  if(module<1 || module>21) { 
    printf("SUMMA module %d is out of [1-21] range\n",module); 
    return -1;
  }

  QBUS qb(qname);
  if(qb.node()<0) return -1;

  LE20C su(&qb, crate);

  LE90M le(&su, module);

  // PRINT
  if (strcmp(argv[4],"print")==0) {
    le.print();
  }
  // READ
  else if(strcmp(argv[4],"read")==0) {
    if(argc<6) {
      printf("Usage: le90m qbus crate module read a\n");
      return -1;
    }
    sscanf(argv[5],"%i",&a);
    //    su.write(module,LE90M_ADDR,a);
    printf("le90m[%d]=%d\n",a,le.read(a));
  }
  // WRITE
  else if(strcmp(argv[4],"write")==0) {
    if(argc<7) {
      printf("Usage: le90m qbus crate module write a p\n");
      return -1;
    }
    sscanf(argv[5],"%i",&a);
    sscanf(argv[6],"%i",&p);
    le.write(a,p);
  }
  else if(strcmp(argv[4],"tbs")==0) {
    if(argc<6) printf("tbs=%d\n",le.tbs()); 
    else {
      sscanf(argv[5],"%i",&a);
      le.write_tbs(a);
    }
  }
  else if(strcmp(argv[4],"tgate")==0) {
    if(argc<6) printf("tgate=%d\n",le.tgate()); 
    else {
      sscanf(argv[5],"%i",&a);
      le.write_tgate(a);
    }
  }
  else if(strcmp(argv[4],"enable")==0) {
    le.enable();
  }
  else if(strcmp(argv[4],"disable")==0) {
    le.disable();
  }
  else if(strcmp(argv[4],"save")==0) {
    if(argc<6) {
      printf("Usage: le90m qbus crate module save filename\n");
      return -1;
    }
    le.save(argv[5]);
  }
  else if(strcmp(argv[4],"load")==0) {
    if(argc<6) {
      printf("Usage: le90m qbus crate module load filename\n");
      return -1;
    }
    le.load(argv[5]);
  }
  // UNKNOWN
  else {
    printf("unknown command: %s\n",argv[4]);
    return -1;
  }

  return 0;
}
