// PR149.CPP - RE149 & RT416 ECL PROM programmer
// Works through QBUS-SUMMA LE20C interface

# include <conio.h>
# include <iostream.h>

# include <device.hpp>

#define ndata 9
int pr149 = 21;  // PR149 module position in crate

int data[9]={3,11,3,1,3,11,3,1,0}; // RE149 data C mu
//int data[9]={1,8,2,8,1,8,2,8,0}; // RE149 data A mu
//int data[8]={3,15,3,15,3,15,3,0}; // RE149 data C hodo
//int data[8]={1,2,1,0,0,0,0,0}; // RE149 data B hodo, mu
//int data[8]={0,0,0,0,0,0,0,0}; // RE149 data

void main(int argc, char **argv)
{
  word in, out;
  word cnt = 0;
  word bit = 0;
  int prog=0;
  QBUS qbus (0x300);     // QBUS IO base address
  LE20C summa (&qbus,4); // crate number

  if(argc<2) prog=0;
  else prog=1;

  cout << "RE149 contents: \n";
  for(cnt=0; cnt<ndata; cnt++) {
    summa.function(pr149,0,17,cnt); // write address
    delay(100);
    in = summa.read (pr149, 1);     // read data
    in = in & 0x000f;
    cout << in << " ";
  }
  cout << "\n";

  if(prog==0) exit(0);

  cout << "Programming RE149: \n";
  for(cnt=0; cnt<ndata; cnt++) {
    summa.function(pr149,0,17,cnt); // write address
    delay(10);
    // loop over 4 bits
    for(bit=0; bit<4; bit++) {
      if(((data[cnt]>>bit)&1)==0) { // we need to program 0
	summa.function(pr149,2,16,(1<<bit)); // set bit
	delay(100);
	cout << cnt << " - " << bit << "\n";
	summa.act(pr149,0,25); // program
	delay(100);
      }
    }
  }

  cout << "RE149 contents: \n";
  for(cnt=0; cnt<ndata; cnt++) {
    summa.function(pr149,0,17,cnt); // write address
    delay(100);
    in = summa.read (pr149, 1);     // read data
    in = in & 0x000f;
    cout << in << " ";
  }
  cout << "\n";

}
