// pulse.cc - test for SUMMA "pulse" module
//
//  Mar-2004 by Solo
//

#include <stdio.h>
#include <string.h>
#include "pulse.h"

int main(int argc, char **argv)
{
  char qname[80]="/dev/qbus0";
  int crate=4;
  int n=14;
  int chan=0;

  if(argc<2) {
    printf("Usage: pulse chan [N] [crate] [qbus]\n");
    printf("       chan  = 0-7  - out channel number or ped,led,oc\n");
    printf("       N     = module number in crate (default 14)\n");
    printf("       crate = 0-15 - summa crate number (default 4)\n");
    printf("       qbus  = 0-1  - qbus number or /dev/xxx (default 0)\n");
    return 0;
  }

  if (argc>4) {
    strncpy(qname,argv[4],sizeof(qname));
    if(argv[1][0]=='0') strcpy(qname,"/dev/qbus0");
    if(argv[1][0]=='1') strcpy(qname,"/dev/qbus1");
  }

  if (argc>3) {
    sscanf(argv[3],"%d",&crate);
    if(crate<0 || crate>15) { 
      printf("SUMMA crate %d is out of [0-15] range\n",crate); 
      return -1;
    }
  }

  if (argc>2) {
    sscanf(argv[2],"%d",&n);
    if(n<0 || n>24) { 
      printf("SUMMA module number %d is out of [0-24] range\n",n); 
      return -1;
    }
  }

  QBUS qb(qname);
  if(qb.node()<0) return -1;

  LE20C su(&qb, crate);

  PULSE pu(&su, n);

  if (strcmp(argv[1],"ped")==0) pu.ped();
  else if (strcmp(argv[1],"led")==0) pu.led();
  else if (strcmp(argv[1],"oc")==0) pu.oc();
  else {
    sscanf(argv[1],"%d",&chan);
    if(chan<0 || chan>7) { 
      printf("channel %d is out of [0-7] range\n",chan); 
      return -1;
    }

    pu.pulse(chan);
  }

  return 0;
}
